/*****************************************************************************\
 * Copyright (c) 2004 Mark Aylett <mark@emantic.co.uk>                       *
 *                                                                           *
 * Permission is hereby granted, free of charge, to any person obtaining a   *
 * copy of this software and associated documentation files (the             *
 * "Software"), to deal in the Software without restriction, including       *
 * without limitation the rights to use, copy, modify, merge, publish,       *
 * distribute, sublicense, and/or sell copies of the Software, and to permit *
 * persons to whom the Software is furnished to do so, subject to the        *
 * following conditions:                                                     *
 *                                                                           *
 * The above copyright notice and this permission notice shall be included   *
 * in all copies or substantial portions of the Software.                    *
 *                                                                           *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS   *
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                *
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN *
 * NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,  *
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR     *
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE *
 * USE OR OTHER DEALINGS IN THE SOFTWARE.                                    *
\*****************************************************************************/

/**
 * \file mar_meta_c.h
 * \brief TODO
 */

#ifndef INCLUDED_MAR_META_C
#define INCLUDED_MAR_META_C

#ifndef INCLUDED_MAR_SEQ_C
#include "mar_seq_c.h"
#endif /* INCLUDED_MAR_SEQ_C */

MAR_EXTERN int
mar_removepairs_(mar_seq_t seq, size_t* isize);

MAR_EXTERN int
mar_setpair_(mar_seq_t seq, size_t* isize, const mar_pair_t* pair,
             size_t* ord);

MAR_EXTERN int
mar_setmeta_(mar_seq_t seq, size_t* isize, size_t ord, const void* data,
             size_t size);

MAR_EXTERN int
mar_unsetbykey_(mar_seq_t seq, size_t* isize, const char* key, size_t* ord);

MAR_EXTERN int
mar_unsetbyord_(mar_seq_t seq, size_t* isize, size_t ord);

MAR_EXTERN const void*
mar_metabykey_(mar_seq_t seq, size_t isize, const char* key, size_t* size);

MAR_EXTERN const void*
mar_metabyord_(mar_seq_t seq, size_t isize, size_t ord, size_t* size);

MAR_EXTERN int
mar_metapair_(mar_seq_t seq, size_t isize, mar_pair_t* pair, size_t ord);

MAR_EXTERN int
mar_tokey_(mar_seq_t seq, size_t isize, mar_key_t key, size_t ord);

MAR_EXTERN int
mar_toord_(mar_seq_t seq, size_t isize, size_t* ord, const char* key);

#endif /* INCLUDED_MAR_META_C */
