/*****************************************************************************\
 * Copyright (c) 2004 Mark Aylett <mark@emantic.co.uk>                       *
 *                                                                           *
 * Permission is hereby granted, free of charge, to any person obtaining a   *
 * copy of this software and associated documentation files (the             *
 * "Software"), to deal in the Software without restriction, including       *
 * without limitation the rights to use, copy, modify, merge, publish,       *
 * distribute, sublicense, and/or sell copies of the Software, and to permit *
 * persons to whom the Software is furnished to do so, subject to the        *
 * following conditions:                                                     *
 *                                                                           *
 * The above copyright notice and this permission notice shall be included   *
 * in all copies or substantial portions of the Software.                    *
 *                                                                           *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS   *
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                *
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN *
 * NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,  *
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR     *
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE *
 * USE OR OTHER DEALINGS IN THE SOFTWARE.                                    *
\*****************************************************************************/

/**
 * \file mar_mfile_c.h
 * \brief TODO
 */

#ifndef INCLUDED_MAR_MFILE_C
#define INCLUDED_MAR_MFILE_C

#ifndef INCLUDED_MAR_STORAGE_C
#include "mar_storage_c.h"
#endif /* INCLUDED_MAR_STORAGE_C */

#ifndef INCLUDED_MAR_TYPES_C
#include "mar_types_c.h"
#endif /* INCLUDED_MAR_TYPES_C */

typedef struct mar_mfile* mar_mfile_t;

MAR_EXTERN int
mar_closemfile_(mar_mfile_t mfile);

MAR_EXTERN mar_mfile_t
mar_openmfile_(const char* path, int flags, mode_t mode, size_t tail);

MAR_EXTERN void*
mar_mapmfile_(mar_mfile_t mfile, size_t size);

MAR_EXTERN int
mar_syncmfile_(mar_mfile_t mfile);

MAR_EXTERN int
mar_truncatemfile_(mar_mfile_t mfile, size_t size);

MAR_EXTERN void*
mar_mfileaddr_(mar_mfile_t mfile);

MAR_EXTERN size_t
mar_mfileresvd_(mar_mfile_t mfile);

MAR_EXTERN size_t
mar_mfilesize_(mar_mfile_t mfile);

MAR_EXTERN void*
mar_mfiletail_(mar_mfile_t mfile);

#endif /* INCLUDED_MAR_MFILE_C */
