/*****************************************************************************\
 * Copyright (c) 2004 Mark Aylett <mark@emantic.co.uk>                       *
 *                                                                           *
 * Permission is hereby granted, free of charge, to any person obtaining a   *
 * copy of this software and associated documentation files (the             *
 * "Software"), to deal in the Software without restriction, including       *
 * without limitation the rights to use, copy, modify, merge, publish,       *
 * distribute, sublicense, and/or sell copies of the Software, and to permit *
 * persons to whom the Software is furnished to do so, subject to the        *
 * following conditions:                                                     *
 *                                                                           *
 * The above copyright notice and this permission notice shall be included   *
 * in all copies or substantial portions of the Software.                    *
 *                                                                           *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS   *
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                *
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN *
 * NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,  *
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR     *
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE *
 * USE OR OTHER DEALINGS IN THE SOFTWARE.                                    *
\*****************************************************************************/

/**
 * \file mar_mmap_c.h
 * \brief TODO
 */

#ifndef INCLUDED_MAR_MMAP_C
#define INCLUDED_MAR_MMAP_C

#ifndef INCLUDED_MAR_STORAGE_C
#include "mar_storage_c.h"
#endif /* INCLUDED_MAR_STORAGE_C */

#ifndef INCLUDED_MAR_TYPES_C
#include "mar_types_c.h"
#endif /* INCLUDED_MAR_TYPES_C */

#define MAR_READ 0x01
#define MAR_WRITE 0x02

typedef struct mar_mmap {
    void* addr_;
    size_t len_;
}* mar_mmap_t;

MAR_EXTERN int
mar_freemmap_(mar_mmap_t mmap_);

MAR_EXTERN mar_mmap_t
mar_createmmap_(int fd, size_t offset, size_t len, int flags);

MAR_EXTERN int
mar_remmap_(mar_mmap_t mmap_, size_t offset, size_t len);

MAR_EXTERN int
mar_syncmmap_(mar_mmap_t mmap_);

MAR_EXTERN size_t
mar_mmapsize_(mar_mmap_t mmap_);

MAR_EXTERN size_t
mar_granularity_(void);

MAR_EXTERN size_t
mar_pagesize_(void);

#endif /* INCLUDED_MAR_MMAP_C */
