/*****************************************************************************\
 * Copyright (c) 2004 Mark Aylett <mark@emantic.co.uk>                       *
 *                                                                           *
 * Permission is hereby granted, free of charge, to any person obtaining a   *
 * copy of this software and associated documentation files (the             *
 * "Software"), to deal in the Software without restriction, including       *
 * without limitation the rights to use, copy, modify, merge, publish,       *
 * distribute, sublicense, and/or sell copies of the Software, and to permit *
 * persons to whom the Software is furnished to do so, subject to the        *
 * following conditions:                                                     *
 *                                                                           *
 * The above copyright notice and this permission notice shall be included   *
 * in all copies or substantial portions of the Software.                    *
 *                                                                           *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS   *
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                *
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN *
 * NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,  *
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR     *
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE *
 * USE OR OTHER DEALINGS IN THE SOFTWARE.                                    *
\*****************************************************************************/

/**
 * \file mar_seq_c.h
 * \brief TODO
 */

#ifndef INCLUDED_MAR_SEQ_C
#define INCLUDED_MAR_SEQ_C

#ifndef INCLUDED_MAR_STORAGE_C
#include "mar_storage_c.h"
#endif /* INCLUDED_MAR_STORAGE_C */

#ifndef INCLUDED_MAR_TYPES_C
#include "mar_types_c.h"
#endif /* INCLUDED_MAR_TYPES_C */

typedef struct mar_seq* mar_seq_t;

MAR_EXTERN int
mar_freeseq_(mar_seq_t seq);

MAR_EXTERN int
mar_copyseq_(mar_seq_t dst, mar_seq_t src);

MAR_EXTERN mar_seq_t
mar_createseq_(size_t tail);

MAR_EXTERN mar_seq_t
mar_openseq_(const char* path, int flags, mode_t mode, size_t tail);

MAR_EXTERN void*
mar_resizeseq_(mar_seq_t seq, size_t size);

MAR_EXTERN int
mar_setregion_(mar_seq_t seq, size_t offset, size_t len);

MAR_EXTERN int
mar_syncseq_(mar_seq_t seq);

MAR_EXTERN void*
mar_seqaddr_(mar_seq_t seq);

MAR_EXTERN size_t
mar_seqsize_(mar_seq_t seq);

MAR_EXTERN void*
mar_seqtail_(mar_seq_t seq);

#endif /* INCLUDED_MAR_SEQ_C */

