#!/bin/sh

MAR=../mar
VI=vi

if [ $# -ne 2 ]; then
	echo "Invalid number of arguments"
	exit 1
fi

ARCHIVE=$2
TMP=tmp.$$

pairs()
{
	echo 'priority=Low'
	echo 'status=Not Started'
}

case $1 in
    -e)
        if [ -f $ARCHIVE ]; then
            $MAR -x $TMP $ARCHIVE
            $VI $TMP && $MAR -i $TMP $ARCHIVE
        else
            $VI $TMP && $MAR -i $TMP $ARCHIVE
            pairs | $MAR -s - $ARCHIVE
        fi
        ;;
    -s)
        if [ -f $ARCHIVE ]; then
            $MAR -t $ARCHIVE > $TMP
        else
            pairs > $TMP
        fi
        $VI $TMP && $MAR -s $TMP $ARCHIVE
        ;;
    *)
        echo "Unknown option"
        exit 1
        ;;
esac

rm -f $TMP
exit 0
