/*****************************************************************************\
 * Copyright (c) 2004 Mark Aylett <mark@emantic.co.uk>                       *
 *                                                                           *
 * Permission is hereby granted, free of charge, to any person obtaining a   *
 * copy of this software and associated documentation files (the             *
 * "Software"), to deal in the Software without restriction, including       *
 * without limitation the rights to use, copy, modify, merge, publish,       *
 * distribute, sublicense, and/or sell copies of the Software, and to permit *
 * persons to whom the Software is furnished to do so, subject to the        *
 * following conditions:                                                     *
 *                                                                           *
 * The above copyright notice and this permission notice shall be included   *
 * in all copies or substantial portions of the Software.                    *
 *                                                                           *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS   *
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF                *
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN *
 * NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,  *
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR     *
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE *
 * USE OR OTHER DEALINGS IN THE SOFTWARE.                                    *
\*****************************************************************************/

static const char rcsid[] = "$Id: mar_debug_c.c,v 1.3 2004/12/14 13:09:23 marayl Exp $";

#include "mar_debug_c.h"

#if defined(WIN32) && !defined(NDEBUG)
static void
mar_dumpclient(void* userdata, size_t size)
{
    char* file;
    int line;
    _ASSERTE(_CrtIsMemoryBlock(userdata,
                               size, NULL, &file, &line));
    MAR_DEBUG_MSG("%s(%d) : Memory leak detected at 0x%p,"
                  " %d byes long", file, line, userdata, size);
}
#endif /* WIN32 && !NDEBUG */

#if defined(WIN32) && !defined(NDEBUG)
MAR_EXTERN void
mar_initleakdump_(void)
{
    _CrtSetReportMode(_CRT_WARN, _CRTDBG_MODE_FILE);
    _CrtSetReportFile(_CRT_WARN, _CRTDBG_FILE_STDERR);
    _CrtSetDumpClient(mar_dumpclient);
}
#endif /* WIN32 && !NDEBUG */

#if defined(WIN32) && !defined(NDEBUG)
MAR_EXTERN void
mar_dumpleaks_(void)
{
    _CrtDumpMemoryLeaks();
}
#endif /* WIN32 && !NDEBUG */
